<?php

function permissions_user ($userid) {
// This simply checks whether the user is an administrator
    $query = 'SELECT is_admin FROM sportsdb_users WHERE userid = ' . $userid;
    $result = mysql_query($query);
    if (mysql_result($result, 0) != 1) {
        return populate_permissions($userid);
    }
    else {
        return mysql_result($result,0);
    }
}

function populate_permissions ($userid) {
// This is run when the user first logs in so that we have an array of all of their permissions

    $permissions_user = array();

    $query = 'SELECT level, type, limitation_value FROM sportsdb_permissions LEFT JOIN sportsdb_limitations 
    ON sportsdb_permissions.policy_id = sportsdb_limitations.policy_id WHERE userid = ' . $userid;
	$result = mysql_query($query);
    while ($permission = mysql_fetch_array($result)) {
        $permissions_user[] = array('perm_level' => $permission['level'], 'lim_type' => $permission['type'], 'lim_value' => $permission['limitation_value']);
    }

    return $permissions_user;
}

function get_permissions ($userid, $level) {
// Populate the permissions when managing a user

    $permissions_user = array();
    
    $query = 'SELECT limitation_id, sportsdb_limitations.policy_id, type, limitation_value FROM sportsdb_permissions LEFT JOIN sportsdb_limitations 
    ON sportsdb_permissions.policy_id = sportsdb_limitations.policy_id 
    WHERE level = \'' . $level . '\' 
    AND userid = ' . $userid . '  
    ORDER BY type ASC, limitation_value ASC';
	$result = mysql_query($query);
    if (!mysql_num_rows($result) ) {
        return false;
    }
    while ($permission = mysql_fetch_array($result)) {
    
        switch ($permission['type']) {
            case 'conf':
                $lim_query = 'SELECT confname FROM sportsdb_conferences WHERE confid = ' . $permission['limitation_value'];
                $lim_result = mysql_query($lim_query);
                $lim_type = 'Conference';
                $lim_name = mysql_result($lim_result, 0) . ' (' . getseasonname($permission['limitation_value']) . ')';
                break;
            case 'div':
                $lim_query = 'SELECT divname, conference FROM sportsdb_divs WHERE divid = ' . $permission['limitation_value'];
                $lim_result = mysql_query($lim_query);
                $lim_type = 'Division';
                $lim_divname = mysql_result($lim_result, 0, 'divname');
                $lim_conference = mysql_result($lim_result, 0, 'conference');
                $lim_conferencename = getconf($lim_conference);
                $lim_seasonname = getseasonname($lim_conference);
                $lim_name = $lim_divname . ' (' . $lim_seasonname . ', ' . $lim_conferencename . ')';
                break;
            case 'team':
                $lim_query = 'SELECT sportsdb_teams.teamname, sportsdb_divs.divname, sportsdb_divs.conference FROM sportsdb_teams, sportsdb_divs WHERE sportsdb_teams.teamid = ' . $permission['limitation_value'] . ' AND sportsdb_teams.teamdiv = sportsdb_divs.divid';
                $lim_result = mysql_query($lim_query);
                $lim_type = 'Team';
                $lim_teamname = mysql_result($lim_result, 0, 'teamname');
                $lim_divname = mysql_result($lim_result, 0, 'divname');
                $lim_conference = mysql_result($lim_result, 0, 'conference');
                $lim_conferencename = getconf($lim_conference);
                $lim_seasonname = getseasonname($lim_conference);
                $lim_name = $lim_teamname . ' (' . $lim_seasonname . ', ' . $lim_conferencename . ', ' . $lim_divname . ')';
                break;
            // Default is NULL
            default:
                return true;
                break;
        }
        
        $permissions_user[] = array('lim_id' => $permission['limitation_id'], 'policy_id' => $permission['policy_id'], 'lim_type' => $lim_type, 'lim_value' => $lim_name);
    }

    return $permissions_user;

}

function full_check ($level) {
// Checks for full permissions to a level

    // Full permissions would have NULL values since they have no limitations
    $check = array('perm_level' => $level, 'lim_type' => NULL, 'lim_value' => NULL);
    
    foreach ($_SESSION['permissions_user'] as $permission) {
        if (in_array($check, $_SESSION['permissions_user'])) {
            return true;
        }
    }
    
    return false;
}

function permissions_check ($level, $conference=NULL, $division=NULL, $team=NULL) {

    // If a conference check was supplied, check that
    if (!is_null(conference)) {
            $check = array('perm_level' => $level, 'lim_type' => 'conf', 'lim_value' => $conference);
        
        foreach ($_SESSION['permissions_user'] as $permission) {
            if (in_array($check, $_SESSION['permissions_user'])) {
                return true;
            }
        }
    }
    
    // If a division check was supplied, check that
    if (!is_null($division)) {
        $check = array('perm_level' => $level, 'lim_type' => 'div', 'lim_value' => $division);
    
        foreach ($_SESSION['permissions_user'] as $permission) {
            if (in_array($check, $_SESSION['permissions_user'])) {
                return true;
            }
        }
    }
    
    // If a division check was supplied, check that
    if (!is_null($team)) {
        $check = array('perm_level' => $level, 'lim_type' => 'team', 'lim_value' => $team);
    
        foreach ($_SESSION['permissions_user'] as $permission) {
            if (in_array($check, $_SESSION['permissions_user'])) {
                return true;
            }
        }
    }
    
    return false;
}

function permissions_table($lims, $level, $userpage=true) {
// Displays what kinds of permissions exist when editing a user
    global $userid;

    if (!$lims) {
        print '<p><em>No permissions</em></p>' . "\n";
        print '<p><form action="' . $_SERVER['PHP_SELF'] . '?action=usersedit&userid=' . $userid . '#permissions" method="post">' . "\n\t";
        print '<input type="hidden" name="perm_level" value="' . $level . '"/>' . "\n\t";
        print '<input type="submit" name="permadd" value="Grant permissions" />' . "\n";
        print '</form></p>' . "\n";
    }
    elseif (!is_array($lims) && $userpage) {
        print '<p><strong>FULL PERMISSIONS</strong></p>' . "\n";
        if ($level != 'manage_conf') {
            print '<p><a href="' . $_SERVER['PHP_SELF'] . '?action=addlim&level=' . $level . '&userid=' . $userid . '">Add a limitation</a></p>' . "\n";
        }
        print '<p><form action="' . $_SERVER['PHP_SELF'] . '?action=usersedit&userid=' . $userid . '#permissions" method="post">' . "\n\t";
        print '<input type="hidden" name="perm_level" value="' . $level . '"/>' . "\n\t";
        print '<input type="submit" name="permdelete" value="Remove permissions" />' . "\n";
        print '</form></p>' . "\n";
        }
    elseif (!is_array($lims) && !$userpage) {
        print '<p>No existing limitations</p>' . "\n";
    }
    else {
        print '<table class="alltables permtable">' . "\n\t";
        print '<tr>' . "\n\t\t";
        print '<th width="35%">Limitation type</th>' . "\n\t\t";
        print '<th width="45%">Limitation value (season, conf, div)</th>' . "\n\t";
        print '<th width="20%"></th> ' . "\n\t";
        print '</tr>' . "\n\t";
        foreach($lims as $lim) {
            print "\n\t" . '<tr>' . "\n\t\t";
            print '<td>' . $lim['lim_type'] . '</td>' . "\n\t\t";
            print '<td>' . $lim['lim_value'] . '</td>' . "\n\t\t";
            print '<td><form action="' . $_SERVER['PHP_SELF'] . '?action=usersedit&userid=' . $userid . '#permissions" method="post">' . "\n\t\t";
            print '<input type="hidden" name="lim_id" value="' . $lim['lim_id'] . '" />' . "\n\t\t";
            print '<input type="submit" name="deletelim" value="Delete" />' . "\n\t\t";
            print '</form></td>' . "\n\t\t";
            print '</td>' . "\n\t";
            print '</tr>';
        }
        print "\n" . '</table>' . "\n";
        if ($userpage) {
            print '<p><a href="' . $_SERVER['PHP_SELF'] . '?action=addlim&level=' . $level . '&userid=' . $userid . '">Add another limitation</a></p>' . "\n";
        }
    }
}

function delete_associated_limitations($delete_type, $delete_id) {
// This is run whenever a conference, division or team is deleted in order to remove associated limitations and, if there are no limitations remaining for a policy, to remove the policy as well

    $query = 'SELECT limitation_id, policy_id FROM sportsdb_limitations WHERE type=\'' . $delete_type . '\' AND limitation_value = ' . $delete_id;
    $result = mysql_query($query);
    while ($policy = mysql_fetch_array($result, MYSQL_ASSOC) ) {
        // Delete that limitation
        mysql_query('DELETE FROM sportsdb_limitations WHERE limitation_id = ' . $policy['limitation_id']);
                    
        // Are there any remaining limitations that deal with that policy?
        $result_remain = mysql_query('SELECT COUNT(*) FROM sportsdb_limitations WHERE policy_id = ' . $policy['policy_id']);
                    
        // If there are no remaining limitations dealing with that policy, delete that policy
        if (!mysql_result($result_remain,0) ) {
            mysql_query('DELETE FROM sportsdb_permissions WHERE policy_id = ' . $policy['policy_id']);
        }
    }
}

function limitation_add($policy_id, $limitation_type_id, $limitation_value) {
    
    switch ($limitation_type_id) {
        case 1:
            $limitation_type = 'conf';
            $limitation_table = 'sportsdb_conferences';
            $limitation_field = 'confid';
            $limitation_id = $limitation_value[0];
            break;
        case 2:
            $limitation_type = 'div';
            $limitation_table = 'sportsdb_divs';
            $limitation_field = 'divid';
            $limitation_id = $limitation_value[1];
            break;
        case 3:
            $limitation_type = 'team';
            $limitation_table = 'sportsdb_teams';
            $limitation_field = 'teamid';
            $limitation_id = $limitation_value[2];
            break;
        default:
            return 'Error adding limitation. Limitation not added';
            break;
    }

    // Check whether this limitation already exists
    $query = 'SELECT COUNT(*) FROM sportsdb_limitations WHERE type = \'' . $limitation_type . '\' AND policy_id = ' . $policy_id . ' AND limitation_value = ' . $limitation_id;
    $result = mysql_query($query);
    if (mysql_result($result,0) != 0) {
        return 'This limitation already exists. Limitation not added';
    }
    
    // Check whether the conference, team or division even exists
    $query = 'SELECT COUNT(*) FROM ' . $limitation_table . ' WHERE ' . $limitation_field . '=' . $limitation_id;
    $result = mysql_query($query);
    if (mysql_result($result,0) == 0) {
        return 'The conference, division, or team to which the limitation applies does not exist. Limitation not added';
    }
    
    // All is OK, add the limitation    
    $query = 'INSERT INTO sportsdb_limitations SET type = \'' . $limitation_type . '\', policy_id = ' . $policy_id . ', limitation_value = ' . $limitation_id;
    if (!mysql_query($query)) {
        return 'Error in query: ' . $query;
    }
    else {
        return 'Limitation added.';
    }
}

function limitation_delete($limitation_id) {
    global $userid;
    // Does this limitation belong to this user?
    $query = 'SELECT userid, sportsdb_permissions.level FROM sportsdb_limitations, sportsdb_permissions 
    WHERE sportsdb_limitations.limitation_id = ' . $limitation_id . ' 
    AND sportsdb_permissions.policy_id = sportsdb_limitations.policy_id';
    $result = mysql_query($query);
    
    if (mysql_num_rows($result) == 0) {
        return 'This limitation does not exist. Limitation not deleted.';
    }
    if (mysql_result($result, 0, 'userid') != $userid) {
        return 'This limitation does not belong to this user. Limitation not deleted.';
    }
    
    // Delete the limitation
    $query = 'DELETE FROM sportsdb_limitations WHERE limitation_id = ' . $limitation_id . ' LIMIT 1';
    if (!mysql_query($query)) {
        return 'Error in query: ' . $query;
    }
    else {
        $level = mysql_result($result, 0, 'level');
        switch ($level) {
            case 'manage_conf':
                $level_display = 'conferences';
                break;
            case 'manage_div':
                $level_display = 'divisions';
                break;
            case 'manage_team':
                $level_display = 'teams';
                break;
            case 'manage_score':
                $level_display = 'scores';
                break;
            default:
                return 'Error in database regarding limitations.';
                break;
        }
        return 'Limitation deleted for managing ' . $level_display . '.';
    }
}

function permission_delete($perm_level) {
    global $userid;

    // Does this permission even exist?
    $query = 'SELECT policy_id FROM sportsdb_permissions  
    WHERE sportsdb_permissions.level = \'' . $perm_level . '\' 
    AND userid = ' . $userid . ' LIMIT 1';
    $result = mysql_query($query);
    
    if (mysql_num_rows($result) == 0) {
        return 'The user does not have the specified permission. No permission removed.';
    }
    
    // Does this permission have limitations (must remove the limitations first)
    $policy_id = mysql_result($result,0);
    $query = 'SELECT COUNT(*) FROM sportsdb_limitations 
    WHERE policy_id = ' . $policy_id;
    $result = mysql_query($query);
    
    if (mysql_result($result,0) != 0) {
        return 'This permission has limitations. Remove the limitations before removing the permission.';
    }
    
    // Remove the permission
    $query = 'DELETE FROM sportsdb_permissions WHERE policy_id = ' . $policy_id . ' LIMIT 1';
    if (!mysql_query($query) ) {
        return 'Error in query: ' . $query;
    }
    else {
        return 'Permission removed' . '.';
    }
}

function permission_add($perm_level) {
    global $userid;

    // Does this permission already exist?
    $query = 'SELECT COUNT(*) FROM sportsdb_permissions  
    WHERE sportsdb_permissions.level = \'' . $perm_level . '\' 
    AND userid = ' . $userid;
    $result = mysql_query($query);
    
    if (mysql_result($result,0) != 0) {
        return 'The user already has the specified permission. No extra permission granted.';
    }
    
    // Add the permission
    $query = 'INSERT INTO sportsdb_permissions SET sportsdb_permissions.level = \'' . $perm_level . '\', userid = ' . $userid;
    if (!mysql_query($query) ) {
        return 'Error in query: ' . $query;
    }
    else {
        return 'Permission granted.';
    }
}

function user_validate($firstname, $lastname, $emailaddy, $username) {

    $errors = array();
    
    // Validate that the username is between 2 and 15 characters
    $username_length = strlen($username);
    if ($username_length <= 2 || $username_length >= 15 ) {
        $errors[] = 'Please enter a username that is between 2 and 15 characters';
    }
    
    $chars = array('-', '_');
    $chars_name = array('-','_','\'',' ');
    
    // Validate that the username has only letters, numbers, underscores, and dashes
    if (!ctype_alnum(str_replace($chars, '', $username) ) ) {
        $errors[] = 'The username can only contain letters, numbers, underscores and dashes.';
    }
    
    // Validate that the first and last names only have letters, numbers, underscores, dashes, apostrophes, and spaces
    if (!ctype_alnum(str_replace($chars_name, '', $firstname) ) ) {
        $errors[] = 'The first name can only contain letters, numbers, apostrophes, spaces, underscores and dashes.';
    }
    
    if (!ctype_alnum(str_replace($chars_name, '', $lastname) ) ) {
        $errors[] = 'The last name can only contain letters, numbers, apostrophes, spaces, underscores and dashes.';
    }
    
    // Validate that it is a properly formed e-mail address
    $regexp = "^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.([a-z]){2,4})$";
    
    if (!eregi($regexp, $emailaddy) ) {
        $errors[] = 'That is not a valid e-mail address.';
    }
    
    if (empty($errors)) {
        return false;
    }
    else {
        return $errors;
    }
}

function password_validate($password1, $password2) {

    $errors = array();
    
    // Validate that the password is between 4 and 15 characters
    $password_length = strlen($password1);
    if ($password_length <= 4 || $password_length >= 15 ) {
        $errors[] = 'Please enter a password that is between 4 and 15 characters.';
    }
    
    // Do both passwords match?
    if ($password1 != $password2) {
        $errors[] = 'The passwords do not match.';
    }
        
    if (empty($errors)) {
        return false;
    }
    else {
        return $errors;
    }
}

function user_last_admin($userid) {
    $query = 'SELECT COUNT(*) FROM sportsdb_users WHERE is_admin = 1 AND userid != ' . $userid;
    $result = mysql_query($query);
    if (mysql_result($result,0) == 0) {
        return true;
    }
    else {
        return false;
    }
}

function user_edit($own_user, $userid, $firstname, $lastname, $emailaddy, $password, $username, $comments=false, $active=false, $is_admin=false) {
    
    // If removing admin status, are there any admins remaining?
    if (!$own_user && (!$is_admin || !$active)) {
        if (user_last_admin($userid)) {
            return 'You cannot remove admin status from this user or make this account inactive because there would be no more administrators remaining.';
        }
    }
    
    // Username should be lower case
    $username = strtolower($username);
    
    // Scrub the comments, first name, and last name (because first name and last name allow for single quotes)
    if (!$own_user) {
        $comments = htmlspecialchars($comments, ENT_QUOTES);
    }
    $firstname = htmlspecialchars($firstname, ENT_QUOTES);
    $lastname = htmlspecialchars($lastname, ENT_QUOTES);
    
    // Ensure that the integer fields are integers
    if (!$own_user) {
        $active = intval($active);
        $is_admin = intval($is_admin);
    }
    
    // Edit the user!
    $query = 'UPDATE sportsdb_users SET firstname = \'' . $firstname . '\', lastname = \'' . $lastname . '\', 
    emailaddy = \'' . $emailaddy . '\'';
    if (!empty($password)) {
        // Encrypt the passowrd
        $password = md5($password);
        $query .= ', password = \'' . $password . '\'';
    }
    // Only update username, comments, active, is_admin if the administrator edited it
    if (!$own_user) {
        $query .= ', username = \'' . $username . '\', comments = \'' . $comments . '\', 
        active = ' . $active . ', is_admin = ' . $is_admin;
    }
    $query .= ' WHERE userid = ' . $userid . ' LIMIT 1';
    if (mysql_query($query)) {
        return false;
    }
    else {
        return 'Error in query: ' . $query;
    }
}

function user_add($firstname, $lastname, $emailaddy, $password, $username, $comments, $is_admin) {
    
    // Username should be lower case
    $username = strtolower($username);
    
    // Validate that the username is unique
    $query = 'SELECT COUNT(*) FROM sportsdb_users WHERE username = \'' . $username . '\'';
    $result = mysql_query($query);
    if (mysql_result($result, 0) != 0) {
        return 'The username already exists.';
    }
    
    // Scrub the comments, first name, and last name (because first name and last name allow for single quotes)
    $comments = htmlspecialchars($comments, ENT_QUOTES);
    $firstname = htmlspecialchars($firstname, ENT_QUOTES);
    $lastname = htmlspecialchars($lastname, ENT_QUOTES);
    
    // Ensure that the admin fields is an integer
    $is_admin = intval($is_admin);

    // Encrypt the passowrd
    $password = md5($password);
        
    // Add the user account
    $query = 'INSERT INTO sportsdb_users 
    (firstname, lastname, emailaddy, password, username, comments, is_admin) ' . 
    "VALUES ('$firstname', '$lastname', '$emailaddy', '$password', '$username', '$comments', $is_admin)";
    
    if (mysql_query($query)) {
        return false;
    }
    else {
        return 'Error in query: ' . $query;
    }
}

function user_delete($userid) {
    // Delete all permissions belonging to this user
    $query = 'SELECT policy_id FROM sportsdb_permissions WHERE userid = ' . $userid;
    $result = mysql_query($query);
    while ($policy = mysql_fetch_array($result, MYSQL_ASSOC) ) {

        // Delete all limitations with this policy
        $query = 'DELETE FROM sportsdb_limitations WHERE policy_id = ' . $policy['policy_id'];
        if (!mysql_query($query)) {
            return 'Error in query: ' . $query;
        }
                    
        // Delete the policy
        $query = 'DELETE FROM sportsdb_permissions WHERE policy_id = ' . $policy['policy_id'] . ' LIMIT 1';
        if (!mysql_query($query)) {
            return 'Error in query: ' . $query;
        }
    }
        
    // Delete this user
    $query = 'DELETE FROM sportsdb_users WHERE userid = ' . $userid . ' LIMIT 1';
    if (!mysql_query($query)) {
        return 'Error in query: ' . $query;
    }
}
?>