<?php
require 'secure.php';
$is_admin = $_SESSION['is_admin'];
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Update Standings</title>
<style type="text/css">
.wrap {
	background: #fff;
	border: 1px solid #ccc;
	clear: both;
	margin: 15px 5%;
	padding: .5em 1em;
}
textarea, input, select {
	background: #f4f4f4;
	border: 1px solid #b2b2b2;
	color: #000;
	font:  13px Verdana, Arial, Helvetica, sans-serif;
	margin: 1px;
	padding: 3px;
}
body, td {
	font: 13px "Lucida Grande", "Lucida Sans Unicode", Tahoma, Verdana;
}
.instructions {
	background-color: #e8e8e8;
	font-style: italic;
	padding: 10px;
	width: 400px;
}
a, a:visited {
	border-bottom: 1px solid #69c;
	color: #00019b;
	text-decoration: none;
}
th {
	text-align: left;
}
.alltables {
border-collapse: collapse;
}

.userstable {
width: 700px;
margin-top: 10px;
margin-bottom: 10px;
}

.permtable, .teamhistory {
width: 500px;
}

.alltables td, .alltables th {
padding: 5px;
border: 1px solid black;
}

.alltables tr {
vertical-align: middle;
}

.lim_action, .user_action {
width: 350px;
background-color: #eeeeee;
border: 1px dotted black;
padding: 10px;
}

#logout {
font-weight: normal;
font-size: 12px;
}

.gray {
color: #888888;
}

.red {
color: #FF0000;
}

.footer {
text-align: center;
margin-bottom: 40px;
font-size: 12px;
}
</style>
</head>
<body>
<div class="wrap">
<h1>Update Standings <span id="logout"><a href="<?php print $_SERVER['PHP_SELF']; ?>?action=logout">LOG OUT</a></span></h1>
<?php

// Get the current year
$year_two = date('Y');

// Allow dates to be set for the past year and the next year
$year_one = $year_two - 1;
$year_three = $year_two + 1;

mysql_connect($sportsdb_host,$sportsdb_user,$sportsdb_pass);
mysql_select_db($sportsdb_db) or die("Unable to select database");

function getdiv($divisionid) {

    $query="SELECT divname FROM sportsdb_divs WHERE divid = $divisionid LIMIT 1";
    $result = mysql_query($query) or die("Error in query: $query");
    $num = mysql_num_rows($result);

    // Does this division exist?
    if($num == 0) die("There is no such division");

    // Otherwise, give its name
    $divname = mysql_result($result,0,"divname");
    return $divname;
}

function getconf($conferenceid) {

    $query = 'SELECT confname FROM sportsdb_conferences WHERE confid = ' . $conferenceid . ' LIMIT 1';
    $result = mysql_query($query) or die("Error in query: $query");
    $num = mysql_num_rows($result);

    // Does this conference exist?
    if($num == 0) die("There is no such conference");

    // Otherwise, give its name
    $confname = mysql_result($result,0);
    return $confname;
}

function getseasonname($conferenceid) {
    $query = 'SELECT sportsdb_seasons.seasonname FROM sportsdb_seasons, sportsdb_conferences WHERE sportsdb_conferences.confid = ' . $conferenceid . ' AND sportsdb_conferences.season = sportsdb_seasons.seasonid LIMIT 1';

    $result = mysql_query($query) or die("Error in query: $query");

    // Return the season name
    $seasonname = mysql_result($result,0);
    $seasonname = htmlspecialchars($seasonname, ENT_QUOTES);
    return $seasonname;
}

$action = $_GET['action'];
switch($action) {

    case 'edit': // Edit a team
    case 'update': // Update a team
    case 'deleteteam': // Delete a team
    case 'add': // Form to add a team
    case 'addyes': // Actually add a team
    case 'addscore': // Form to add a score
    case 'addscoreyes': // Actually add a score
    case 'editscore': // Form to edit a score
    case 'updatescore': // Actually edit a score
    case 'deletescore': // Confirm the deletion of a score
    case 'deleteyes': // Actually delete a score
    case 'conferences': // Form to manage conferences
    case 'editconferences': // Actually edit and possibly add a conference
    case 'deleteconference': // Actually delete a conference
    case 'divisions': // Form to manage divisions
    case 'editdivisions': // Actually edit and possibly add a division
    case 'deletedivision': // Actually delete a division
    case 'seasons': // Form to manage seasons
    case 'editseasons': // Actually edit and possibly add a season
    case 'deleteseason': // Actually delete a season
    case 'masterteams': // Form to manage master teams
    case 'editmasterteams': // Actually edit and possibly add a master team
    case 'deletemasterteam': // Actually delete a master team
    case 'showmasterteams': // Show the teams that belong to a master team
    case 'mainview': // List the divisions, teams, and scores in a conference
    case 'updateeverysingleteam': // Safety script to recalculate all standings
    case 'users': // Main user and permission management page
    case 'usersedit': // Form to edit a user
    case 'usersadd': // Form to add a user
    case 'addlim': // Add a limitation
    case 'usersedityes': // Actually edit a user
    case 'usersdelete': // Delete a user    
    case 'logout': // Log out
        include $admin_dir . $action . '.php';
    break;

    default:

        if ($is_admin) {
            print '<p><a href="' . $_SERVER['PHP_SELF'] . '?action=users">Manage users</a></p>' . "\n";
        }
    
        $ss_thisuser = $_SESSION['userid'];
        print '<p><a href="' . $_SERVER['PHP_SELF'] . '?action=usersedit&userid=' . $ss_thisuser . '">Edit my profile</a></p>' . "\n";
        print '<h2>Seasons and conferences</h2>' . "\n";
        if ($is_admin) {
            print '<div class="instructions">' . "\n";
            print '<p>Click <a href="' . $_SERVER['PHP_SELF'] . "?action=masterteams\">here</a> to manage master teams.</p>\n";
            print '<p>Click <a href="' . $_SERVER['PHP_SELF'] . "?action=seasons\">here</a> to manage seasons.</p>\n";
            print "</div>\n";
        }
        $query = 'SELECT seasonid, seasonname FROM sportsdb_seasons ORDER BY seasonorder';
        $result = mysql_query($query) or die("Error in query $query");
        $num = mysql_num_rows($result);

        while ($seasons = mysql_fetch_array($result)) {
            $seasonname = htmlspecialchars($seasons['seasonname'], ENT_QUOTES);
            print '<h3>' . $seasonname;
            if ($is_admin || full_check('manage_conf') ) {
                print '<span style="font-size: 12px;"> - <a href="' . $_SERVER['PHP_SELF'] . '?action=conferences&season=' . $seasons['seasonid'] . '">manage conferences</a></span>';
            }
            print '</h3>' . "\n";

            // List the conferences in each season
            $queryconf = 'SELECT confid, confname FROM sportsdb_conferences WHERE season = ' . $seasons['seasonid'] . ' ORDER BY conforder';
            $resultconf = mysql_query($queryconf) or die ('Error in query ' . $queryconf);
            $numconf = mysql_num_rows($resultconf);

            while ($confs = mysql_fetch_array($resultconf)) {
                print '<p><a href="' . $_SERVER['PHP_SELF'] . "?action=mainview&conf={$confs['confid']}\">{$confs['confname']}</a></p>\n";
            }
        }
    
        if ($is_admin) {
            print "<hr />\n<p><a href=\"" . $_SERVER['PHP_SELF'] . "?action=updateeverysingleteam\">Update all team data (this takes a while -- do only if necessary)</a></p>\n";
        }
}
?>
</div>
<?php include 'footer.php'; ?>
</body>
</html>